/***********************************************************************
** Program: Oszacowanie Monte Carlo
** Autor: Marek Hac
** Data: 29.05.2006
** Wersja dla AmigaOS
***********************************************************************/

#include <iostream.h>
#include <proto/intuition.h>
#include <proto/utility.h>
#include <proto/muimaster.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <dos/dos.h>
#include <machine/reg.h>
#include <exec/libraries.h>
#include <exec/types.h>
#include <intuition/intuition.h>
#include <clib/alib_protos.h>
#include <libraries/mui.h>
#include <stdio.h>
#include <graphics/gfx.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>
#include "metody_pseudolosowe.h"
#include "wstawka_asm.h"

BOOL czy_Obiecujacy (int);
void queens (int,ULONG);
void Wyczysc_szachownice();
struct Library *MUIMasterBase;

Object *Program, *Okno, *Grupa, *Suwak, *TxtButt, *Srednia, *Lista;
Object *ibButton[10][10];

const int max=101;
      int col[100];
      int n;

class TStos
{
  private:
   int adres_wierzch;
   int tab[max];
   public:
   void push (int nowy);
   int pop();
   BOOL isempty();
   BOOL isfull();
   void clear();
   BOOL contains(int);
   TStos();
};

/**************************
** Definicja klasy TStos
**************************/

TStos::TStos()
{
	adres_wierzch=-1;
};

BOOL TStos::isfull()
{
  return adres_wierzch==max-1;
};

BOOL TStos::isempty()
{
  return adres_wierzch==-1;
};

void TStos::push(int nowy)
{
   adres_wierzch++;
   tab[adres_wierzch]=nowy;
};

int TStos::pop()
{
   int rob=adres_wierzch;
   adres_wierzch--;
   return tab[rob];
};

void TStos::clear()
{ // czyszczenie stosu

	for (int i=0;i<=adres_wierzch;i++)
	 tab[i]=0;
	 adres_wierzch = -1;
}

BOOL TStos::contains(int szukana)
{ // metoda sprawdza czy dana liczba jest na stosie

  int pom = adres_wierzch;

   for (int i=0;i<=pom;i++)
    {
      if (tab[i]==szukana)

       return TRUE;
    }
  return FALSE;
}

/*********************************
* Definicja metody czy_Obiecujacy
*********************************/

BOOL czy_Obiecujacy (int i)
{
  int k;
  BOOL obiecujacy;

  k = 1;
  obiecujacy = TRUE;

  while (k<i && obiecujacy == TRUE)
   {
     if (col[i] == col[k] || abs (col[i]-col[k])==(i-k))
       obiecujacy = FALSE;

     k++;
   }

  return obiecujacy;
}

/*******************************
** Definicja metody monte_carlo
*******************************/

long double monte_carlo(int n)
{
  int i, j;
  double liczba;
  int liczba_ob_potomkow;
  long double suma_ob_potomkow, ilosc_spr_wezlow;
  TStos obiecujacy_potomek;

  i = 0;
  ilosc_spr_wezlow = 1;
  liczba_ob_potomkow = 1;
  suma_ob_potomkow = 1;

  while (liczba_ob_potomkow != 0 && i != n)
   {
     suma_ob_potomkow = suma_ob_potomkow * liczba_ob_potomkow;
     ilosc_spr_wezlow = ilosc_spr_wezlow + suma_ob_potomkow * n;

     i++;
     liczba_ob_potomkow = 0;
     obiecujacy_potomek.clear();
     for (j = 1; j <=n; j++)
       {
            col[i] = j;
             if (czy_Obiecujacy (i))
               {
                 liczba_ob_potomkow++;
                 obiecujacy_potomek.push(j);
               }
       }
     if (liczba_ob_potomkow != 0)
       {
           do
				{
              liczba = rnd();
              liczba=(unsigned(liczba*10000))%100%n;

              j = (int)liczba+1;

            }

          while (obiecujacy_potomek.contains(j) == FALSE);
        col [i] = j;
        }
   }

return ilosc_spr_wezlow;
}

/*****************************
** Definicja metody Symulacja
*****************************/

long Symulacja (REG(a0) struct Hook *hook, REG(a2) Object *obj, REG(a1) long *nic)
{
  long double liczba;
  long double suma = 0;
         char textl[64];
         char suma_char[64];

  ULONG *wymiar;
  wymiar = new ULONG ;

   DoMethod(Lista,MUIM_List_Clear); //czyszczenie listy

   GetAttr(MUIA_Slider_Level,Suwak,wymiar); // pobranie wymiarow szachownicy

    n=(int)(*wymiar);

   for (int x=1;x<=20;x++)
    {
      liczba = monte_carlo(n);
      suma = suma+liczba;

      sprintf (textl, "%LE", liczba);

      DoMethod (Lista, MUIM_List_InsertSingle,textl, x);
    }

    suma = suma/20; // wyznaczenie sredniej

    sprintf (suma_char, "%LE", suma);


    DoMethod (Srednia, MUIM_Set, MUIA_Text_Contents, suma_char);

  delete wymiar;
  return 0;
 }

struct Hook h_Symulacja = {NULL, NULL, (HOOKFUNC)Symulacja, NULL, NULL};

/**************************************************************/

int main (void)
{
  unsigned long signals;
  struct IntuitionBase *IntuitionBase=NULL;

   if (IntuitionBase = (struct IntuitionBase*)
   OpenLibrary ("intuition.library",37))
   {
    if (MUIMasterBase = OpenLibrary ("muimaster.library", 19))
     {
      if (Program = MUI_NewObject (MUIC_Application,
       MUIA_Application_Author,      (long)"Marek Ha",
       MUIA_Application_Base,        (long)"monte carlo",
       MUIA_Application_Copyright,   (long)"Freeware",
       MUIA_Application_Description, (long)"oszacowanie",
       MUIA_Application_Title,       (long)"Oszacowanie Monte Carlo",
       MUIA_Application_Window,      Okno = MUI_NewObject (MUIC_Window,
         MUIA_Window_Activate,         TRUE,
         MUIA_Window_ID,               0x4F445752,
         MUIA_Window_Title,            (long)"Oszacowanie Monte Carlo -  2006 Marek Ha",
         MUIA_Window_RootObject,       Grupa = MUI_NewObject (MUIC_Group,
           MUIA_Group_Horiz,             TRUE,
           MUIA_Group_Child,             (long)MUI_NewObject (MUIC_Group,
                  MUIA_Group_Rows, 1,
             MUIA_Group_Columns,           2,
             MUIA_Group_Spacing,           2,


	// poczatek grupy "Panel listy"

	MUIA_Group_Child, MUI_NewObject (MUIC_Group,
      MUIA_Group_Horiz, FALSE,
      MUIA_Frame, MUIV_Frame_Group,
      MUIA_Background, MUII_GroupBack,
                   MUIA_Group_Rows, 1,
 	MUIA_Group_Columns,           1,
      MUIA_Group_Spacing,           3,

	// poczatek grupy "Wyniki"

	MUIA_Group_Child, MUI_NewObject (MUIC_Group,
   	   MUIA_Group_Horiz, FALSE,
      	MUIA_Frame, MUIV_Frame_Group,
	      MUIA_Background, MUII_GroupBack,
	      MUIA_FrameTitle, (long)"Wyniki",
   	   MUIA_Group_Rows, 1,
      	MUIA_Group_Spacing, 3,

	MUIA_Group_Child, Lista = MUI_NewObject (MUIC_Listview,
   	   MUIA_Listview_List, MUI_NewObject (MUIC_List,
      	MUIA_List_ConstructHook, MUIV_List_ConstructHook_String,
       	MUIA_List_DestructHook, MUIV_List_DestructHook_String,
      	MUIA_Frame, MUIV_Frame_ReadList,
      TAG_END),
	TAG_END),

 End, // koniec grupy "Wybierz rozwiazanie"

End,// koniec grupy "Panel listy"

MUIA_Group_Child, MUI_NewObject (MUIC_Group,
      MUIA_Group_Horiz, FALSE,
      MUIA_Frame, MUIV_Frame_Group,
      MUIA_Background, MUII_GroupBack,
                   MUIA_Group_Rows, 6,
 MUIA_Group_Columns,           1,
      MUIA_Group_Spacing,           4,

// napisy

MUIA_Group_Child, MUI_NewObject (MUIC_Text,
		MUIA_Text_Contents,
		"\33c\33b\nOszacowanie Monte Carlo\n",TAG_END),

MUIA_Group_Child, MUI_NewObject (MUIC_Text,
		MUIA_Text_Contents,
		"\33cOszacowanie zoonoci obliczeniowej\nalgorytmu z powrotami\ndla\n\33uproblemu n-krlowych\n",TAG_END),

 // poczatek grupy "Wymiar szachownicy"

MUIA_Group_Child, MUI_NewObject (MUIC_Group,
      MUIA_Group_Horiz, FALSE,
      MUIA_Frame, MUIV_Frame_Group,
      MUIA_Background, MUII_GroupBack,
      MUIA_FrameTitle, (long)"Wymiar szachownicy",
      MUIA_Group_Rows, 1,
      MUIA_Group_Spacing, 2,


			MUIA_Group_Child, Suwak = MUI_NewObject (MUIC_Slider,
             MUIA_Slider_Horiz, TRUE,
             MUIA_Numeric_Min, 4,
             MUIA_Numeric_Max, 100,
             TAG_END),

	End, // koniec grupy Wymiar szachownicy

// przycisk "Start"

MUIA_Group_Child,  TxtButt = MUI_NewObject (MUIC_Text,
               MUIA_Frame,  MUIV_Frame_Button,
               MUIA_Background, MUII_ButtonBack,
               MUIA_Font, MUIV_Font_Button,
               MUIA_InputMode,  MUIV_InputMode_RelVerify,
               MUIA_Text_Contents,  (long)"\33c S T A R T",
               TAG_END),

// koniec "Start"
// poczatek grupy "Wyniki"

  MUIA_Group_Child, MUI_NewObject (MUIC_Group,
      MUIA_Group_Horiz, FALSE,
      MUIA_Frame, MUIV_Frame_Group,
      MUIA_Background, MUII_GroupBack,
      MUIA_FrameTitle, (long)"Wyniki",
      MUIA_Group_Rows, 3,
      MUIA_Group_Spacing,           2,


		MUIA_Group_Child, MUI_NewObject (MUIC_Text,
		MUIA_Text_Contents,
		"\33crednia liczba wezw\nsprawdzonych przez algorytm\nz powrotami",
		TAG_END),

// pole "Srednia"

 		   MUIA_Group_Child, Srednia = MUI_NewObject (MUIC_Text,
	       MUIA_Frame, MUIV_Frame_Text,
	       MUIA_Background, MUII_TextBack,
	       TAG_END),

// koniec pola "Srednia"
End, // koniec grupy "Wyniki"
End, // koniec grupy Panel

TAG_END),
TAG_END),
TAG_END)))

{
  // Notyfikacje

  DoMethod (TxtButt, MUIM_Notify, MUIA_Pressed, FALSE, Suwak,
    2, MUIM_CallHook, &h_Symulacja);

  DoMethod (Okno, MUIM_Notify, MUIA_Window_CloseRequest, MUIV_EveryTime,
   Program, 2, MUIM_Application_ReturnID, MUIV_Application_ReturnID_Quit);

  SetAttrs (Okno, MUIA_Window_Open, TRUE, TAG_END);

    while (DoMethod (Program, MUIM_Application_NewInput, &signals) !=
      MUIV_Application_ReturnID_Quit)
        {
          if (signals)
            {
              signals = Wait (signals | SIGBREAKF_CTRL_C);
              if (signals & SIGBREAKF_CTRL_C) break;
            }
        }

          SetAttrs (Okno, MUIA_Window_Open, FALSE, TAG_END);

          MUI_DisposeObject (Program);
        }

      CloseLibrary (MUIMasterBase);
     }
    CloseLibrary ((struct Library*)IntuitionBase);
   }
 return 0;
 }

